print ("*************************************************************************************");
print ("**** Mod: InGameMenuEnhancement V3.0");
print ("**** Part of Mod: CompleteFruitExpansion or Früchtemodifizierung");
print ("**** Made by: (c)BlueTiger");
print ("**** All Rights Reserved By: Austrian Company Team-SUB7");
print ("**** BlueTiger is a synonym used by Team-SUB7");
print ("**** Credits: Thanks to all Helpers and Testers");
print ("**** Informer: Madjack, mor2000, Marhu");
print ("**** Tester: Aerox1939, Modsauger");
print ("*************************************************************************************");
ts7_n_IGME = {};

SowingMachine.postLoad = function (self, xmlFile)
	self.seeds = {};
	for index,fruit in pairs(g_currentMission.fruits) do
			local desc = FruitUtil.fruitIndexToDesc[index];
			if desc.allowsSeeding then
				table.insert(self.seeds, desc.index);
			end
	end
end

function ts7_n_IGME:loadMap(name)
	ts7_n_IGME_main();
end

function ts7_n_IGME:deleteMap()
end

function ts7_n_IGME:mouseEvent(posX, posY, isDown, isUp, button)
	if g_gui.currentGuiName == "InGameMenu" then
		if g_inGameMenu.mode == InGameMenu.MODE_MAP_VIEWS then
			if g_inGameMenu.mapView == InGameMenu.MAP_VIEW_FRUIT_TYPES then
				if Input.isMouseButtonPressed(Input.MOUSE_BUTTON_WHEEL_UP) then
					ts7_n_IGME_onClickBtnFruitViewUp();
				end
				if Input.isMouseButtonPressed(Input.MOUSE_BUTTON_WHEEL_DOWN) then
					ts7_n_IGME_onClickBtnFruitViewDown();
				end
			end
		end
	end
end

function ts7_n_IGME:keyEvent(unicode, sym, modifier, isDown)
end

function ts7_n_IGME:update(dt)
	ts7_n_IGME_main();
end

function ts7_n_IGME:updateTick(dt)
	ts7_n_IGME_main();
end

function ts7_n_IGME:draw()
end
ts7_n_IGME_drawDynamicMapImage = function(self, l_56_1) --modified from InGameMenu.lua
	for igor,fOver in pairs (self.foliageStateOverlays) do
		renderOverlay(fOver, l_56_1.absPosition[1], l_56_1.absPosition[2], l_56_1.size[1], l_56_1.size[2]);
	end
end
ts7_n_IGME_onOpen = function(self, element) --modified from InGameMenu.lua
	if self.foliageStateOverlays == nil then
		self.foliageStateOverlays = {};
	end
	for igor, fOver in pairs (self.foliageStateOverlays) do
		resetFoliageStateOverlay(fOver);
	end
	if not self.ignoreOnClose then
		self.continueButton:setDisabled(false);
		self.continueEnabled = true;
		self.errorText:setVisible(false);
		if g_currentMission ~= nil and not g_currentMission.missionDynamicInfo.isMultiplayer then
			g_currentMission:pauseGame();
		end
		InputBinding.setShowMouseCursor(true);
		self.playerAlreadySaved = false;
	end
	self.toggleResetItemElement:setIsChecked(false);
	if g_currentMission.pdaMapOverlay ~= nil then
		setOverlayUVs(g_currentMission.pdaMapOverlay.overlayId, 0, 0, 0, 1, 1, 0, 1, 1);
	end
	self:updateGUI();
	self.timeScale = g_currentMission.missionStats.timeScale;
	if not g_currentMission:getIsServer() then
		local hasMasterRights = g_currentMission.isMasterUser;
	end
	self.timeScaleElement:setState(Utils.getTimeScaleIndex(self.timeScale));
	self.timeScaleElement:setDisabled(not hasMasterRights);
	self.helpText = g_currentMission.showHelpText;
	self.missionFrequencyElement:setState(g_currentMission.missionStats.missionFrequency);
	self.missionFrequencyElement:setDisabled(not g_isDemo and ((hasMasterRights and not g_currentMission.missionInfo:isa(FSCareerMissionInfo))));
	self.plantGrowthRateElement:setState(g_currentMission.missionStats.plantGrowthRate);
	self.plantGrowthRateElement:setDisabled(not hasMasterRights);
	self.helpIcons = g_currentMission.showHelpIcons;
	self.helpIconsElement:setIsChecked(self.helpIcons);
	self.showIconsOnPDA = g_currentMission.missionStats.showIconsOnPDA;
	self.showIconsElement:setIsChecked(self.showIconsOnPDA);
	if g_currentMission.isMasterUser then
		self.saveRestartButton:setDisabled(false);
	end
	self.vehicleIcon:setVisible(false);
	self.vehicleName:setText("");
	self:updateFocusLinkageSystem();
end
ts7_n_IGME_setMissionInfo = function(self, missionInfo, missionDynamicInfo) --modified from InGameMenu.lua
	self.missionInfo = missionInfo
	self.missionDynamicInfo = missionDynamicInfo
	if self.foliageStateOverlays == nil then
		self.foliageStateOverlays = {};
	end
	for igor, fOver in pairs (self.foliageStateOverlays) do
		resetFoliageStateOverlay(fOver);
	end
	if missionInfo:isa(FSCareerMissionInfo) then
		for i = 1, 3 do
			self.briefingImages[i]:setImageFilename(self.missionInfo.briefingImagePrefix .. "_briefing" .. i .. ".png");
		end
		self.infoText:setText("");
		self.saveRestartButton:setText(g_i18n:getText("Button_SaveGame"));
	else
		for i = 1, 3 do
			if self.missionInfo.briefingImageBasePath ~= nil then
				self.briefingImages[i]:setImageFilename(self.missionInfo.briefingImageBasePath .. i .. ".png");
			else
				self.briefingImages[i]:setImageFilename("dataS2/menu/briefingScreen/blank.png");
			end
		end
		self.saveRestartButton:setText(g_i18n:getText("Button_RestartGame"));
	end
	if (missionDynamicInfo.isMultiplayer and missionDynamicInfo.isClient) or g_isGamescomVersion then
		self.saveRestartButton:setDisabled(true);
	else
		self.saveRestartButton:setDisabled(false);
	end
end
ts7_n_IGME_onCreateBtnFruitViewUp = function (self,l_39_1)
	g_inGameMenu.btnFruitViewUp = l_39_1;
	g_gui.guis["InGameMenu"].btnFruitViewUp = l_39_1;
	g_inGameMenu.btnFruitViewUp = l_39_1;
	g_inGameMenu.btnFruitViewUp:setVisible(false);
end
ts7_n_IGME_onCreateBtnFruitViewDown = function (self,l_29_1)
	g_inGameMenu.btnFruitViewDown = l_29_1;
	g_gui.guis["InGameMenu"].btnFruitViewDown = l_29_1;
	g_inGameMenu.btnFruitViewDown = l_29_1;
	g_inGameMenu.btnFruitViewDown:setVisible(false);
end
ts7_n_IGME_onClickBtnFruitViewUp = function (self)
	--Wenn hinaufgeklickt wird, Zeile-1
	if g_inGameMenu.FruitViewBeginRow > 1  then
		g_inGameMenu.FruitViewBeginRow = g_inGameMenu.FruitViewBeginRow - 1;
		g_inGameMenu:updateGUI();
	end
end
ts7_n_IGME_onClickBtnFruitViewDown = function (self)
	--Wenn Runter geklickt wird, Zeile + 1;
	if g_inGameMenu.btnFruitViewDown.visible then
		g_inGameMenu.FruitViewBeginRow = g_inGameMenu.FruitViewBeginRow + 1;
		g_inGameMenu:updateGUI();
	end
end
ts7_n_IGME_isVisibleFruit = function (self, name)
	local strTemp = ts7_mods["InGameMenuEnhancement"].invisible;
	local bNotFound = true;
	for k in string.gfind(strTemp, "(%a+)") do
		if name == k then
			bNotFound = false;
		end
	end
	return bNotFound;
end
ts7_n_IGME_updateGUI = function (self) --modified from InGameMenu.lua
	local tmpParent = g_gui.guis["InGameMenu"].elements[1].elements[2];
	local strMod = "InGameMenuEnhancement";
	local optionXmlFile = ts7_mods[strMod].file;
	local bFruitUpdate = false;
	if FruitUtil.NUM_FRUITTYPES > ts7_mods[strMod].fruittypes then
		bFruitUpdate = true;
	end
	if ts7_mods[strMod].reload or bFruitUpdate then
		local xmlFile = loadXMLFile("Temp", optionXmlFile);
		local eof = false;
		local strTemp = "";
		local fi = 0;
		local fj = 0;
		local qString = strMod..".GuiElement(";
		if ts7_mods[strMod].reload then
			repeat
				strTemp = getXMLString(xmlFile,strMod..".Option("..fi..")#type");
				if strTemp ~= nil then
					ts7_mods[strMod][strTemp] = getXMLString(xmlFile,strMod..".Option("..fi..")#value");
					fi = fi + 1;
				else
					eof = true;
				end
			until eof
			if ts7_mods[strMod].columns ~= nil then
				if tonumber (ts7_mods[strMod].columns) ~= nil then
					ts7_mods[strMod].columns = tonumber (ts7_mods[strMod].columns);
				else
					ts7_mods[strMod].columns = 2;
				end		
			else
				ts7_mods[strMod].columns = 2;
			end
			if ts7_mods[strMod].textSize ~= nil then
				if tonumber (ts7_mods[strMod].textSize) ~= nil then
					ts7_mods[strMod].textSize = tonumber (ts7_mods[strMod].textSize);
				else
					ts7_mods[strMod].textSize = 0.016;
				end		
			else
				ts7_mods[strMod].textSize = 0.016;
			end
			if ts7_mods[strMod].spacer ~= nil then
				if tonumber (ts7_mods[strMod].spacer) ~= nil then
					ts7_mods[strMod].spacer = tonumber (ts7_mods[strMod].spacer);
				else
					ts7_mods[strMod].spacer = 0.005;
				end		
			else
				ts7_mods[strMod].spacer = 0.005;
			end
			--XmlFile anpassen
			fi = 0;
			repeat
				local iTmp = fi + 1;
				setXMLString (xmlFile,qString..fi..")#type","bitmap");
				setXMLString (xmlFile,qString..fi..")#id","keyBorderN["..iTmp.."]");
				setXMLString (xmlFile,qString..fi..")#position","0.0 0.0");
				setXMLString (xmlFile,qString..fi..")#size","0.0 0.0");
				setXMLString (xmlFile,qString..fi..")#imageFilename","dataS2/menu/black.png");
				setXMLString (xmlFile,qString..fi..")#imageColor","1 1 1 1");
				fi = fi + 1;
			until fi == ts7_mods[strMod].columns;
			setXMLString (xmlFile,qString..fi..")#type","button");
			setXMLString (xmlFile,qString..fi..")#profile","defaultButton");
			setXMLString (xmlFile,qString..fi..")#position","0.1 0.85");
			setXMLString (xmlFile,qString..fi..")#imageFilename","$GUILocation/menu/button_up_normal.png");
			setXMLString (xmlFile,qString..fi..")#imageFocusedFilename","$GUILocation/menu/button_up_focused.png");
			setXMLString (xmlFile,qString..fi..")#imagePressedFilename","$GUILocation/menu/button_up_pressed.png");
			--setXMLString (xmlFile,qString..fi..")#text","Auf");
			setXMLString (xmlFile,qString..fi..")#onClick","onClickBtnFruitViewUp");
			setXMLString (xmlFile,qString..fi..")#onCreate","onCreateBtnFruitViewUp");
			setXMLString (xmlFile,qString..fi..")#focusId","120");
			setXMLString (xmlFile,qString..fi..")#focusChangeRight","121");
			setXMLString (xmlFile,qString..fi..")#focusChangeTop","5");
			setXMLString (xmlFile,qString..fi..")#focusChangeBottom","5");
			fi = fi + 1;
			setXMLString (xmlFile,qString..fi..")#type","button");
			setXMLString (xmlFile,qString..fi..")#profile","defaultButton");
			setXMLString (xmlFile,qString..fi..")#position","0.8 0.095");
			setXMLString (xmlFile,qString..fi..")#imageFilename","$GUILocation/menu/button_down_normal.png");
			setXMLString (xmlFile,qString..fi..")#imageFocusedFilename","$GUILocation/menu/button_down_focused.png");
			setXMLString (xmlFile,qString..fi..")#imagePressedFilename","$GUILocation/menu/button_down_pressed.png");
			--setXMLString (xmlFile,qString..fi..")#text","Runter");
			setXMLString (xmlFile,qString..fi..")#onClick","onClickBtnFruitViewDown");
			setXMLString (xmlFile,qString..fi..")#onCreate","onCreateBtnFruitViewDown");
			setXMLString (xmlFile,qString..fi..")#focusId","121");
			setXMLString (xmlFile,qString..fi..")#focusChangeRight","120");
			setXMLString (xmlFile,qString..fi..")#focusChangeTop","5");
			setXMLString (xmlFile,qString..fi..")#focusChangeBottom","5");
			fi = fi + 1;
		end
		if bFruitUpdate then		
			fj = ts7_mods[strMod].fruittypes + 1;
			repeat
				setXMLString (xmlFile,qString..fi..")#type","bitmap");
				setXMLString (xmlFile,qString..fi..")#id","keyColor["..fj.."+(24*4)]");
				setXMLString (xmlFile,qString..fi..")#position","0.0 0.0");
				setXMLString (xmlFile,qString..fi..")#size","0.0 0.0");
				setXMLString (xmlFile,qString..fi..")#imageFilename","dataS2/menu/white.png");
				setXMLString (xmlFile,qString..fi..")#imageColor","1 0 1 1");
				fi = fi + 1;
				setXMLString (xmlFile,qString..fi..")#type","text");
				setXMLString (xmlFile,qString..fi..")#id","keyText["..fj.."+24]");
				setXMLString (xmlFile,qString..fi..")#profile","defaultText");
				setXMLString (xmlFile,qString..fi..")#position","0.0 0.0");
				setXMLString (xmlFile,qString..fi..")#textSize","0.016");
				setXMLString (xmlFile,qString..fi..")#text2Size","0.016");
				setXMLString (xmlFile,qString..fi..")#alignment","left");
				setXMLString (xmlFile,qString..fi..")#text","");
				fi = fi + 1;
				fj = fj + 1;
			until fj > FruitUtil.NUM_FRUITTYPES;
			g_gui:loadGuiRec(xmlFile, strMod, tmpParent, g_inGameMenu);
		end
		delete(xmlFile);
		ts7_mods[strMod].reload = false;
		bFruitUpdate = false;
		ts7_mods[strMod].fruittypes = FruitUtil.NUM_FRUITTYPES;
	end
	--Einlesen per XML auserhalb!
	local tmpColumns = ts7_mods[strMod].columns;
	local tmpSpace = ts7_mods[strMod].spacer;
	local tmpTextSize = ts7_mods[strMod].textSize;
	if tmpColumns == nil then
		tmpColumns = 2;
	end
	
	--Fixe Werte
	local tmpGrowthTextSize = 0.024;
	local tmpMaxWidth = 0.520;
	local tmpMaxHeight = 0.525;
	local tmpIgnore = 24;
	local tmpIgnoreKeyColor = tmpIgnore * 4;
	local tmpKeyTextPosY = 0.800;
	
	--Berechnete Werte
	--local tmpMaxVisibleFruits = FruitUtil.NUM_FRUITTYPES;
	local tmpColumnWidth = tmpMaxWidth / (tmpColumns + 1);
	local tmpBmpSqrSize = tmpTextSize;
	local tmpGrowthBmpSqrSize = tmpGrowthTextSize;
	local keyTextPosX = self.keyTextPosX;
	local tmpMaxRowsVisible = math.floor(tmpMaxHeight / (tmpTextSize+tmpSpace));
	
	--Läufervariablen
	local tmpColumn = 0;
	local tmpRows = 1;
	local tmpFruits = 0;
	if self.foliageStateOverlays == nil then
		self.foliageStateOverlays = {};
	end
	local files = {};
	local file;
	local indi = 1;
	local vorhanden = false;
	for ts7nindex,ts7nfruit in pairs (g_currentMission.fruits) do
		if ts7nfruit.id ~= 0 then
			file = getDensityMapFileName(ts7nfruit.id);
			if files ~= nil then
				for inder,fname in pairs (files) do
					if fname == file then
						vorhanden = true;
					end
				end
			end
			if vorhanden == false then
				files[indi] = file;
				indi = indi + 1;
			else
				vorhanden = false;
			end
		end
	end
	for inder,fname in pairs (files) do
		self.foliageStateOverlays[inder] = createFoliageStateOverlay("foliageState",256,256);
	end
	g_inGameMenu.densityMapFileNames = files;
	if g_gui.currentGuiName ~= "InGameMenu" then
		return;
	end
	for _,element in pairs(self.modeGUIElements) do
		element.visible = false;
	end
	self.modeGUIElements[self.mode].visible = true;
	self.infoText:setText("");
	if self.mode == InGameMenu.MODE_BRIEFING then
		return;
	end
	if self.mode == InGameMenu.MODE_MAP_VIEWS then
		--Elemente unsichtbar machen
		for i,v in pairs(self.keyColor) do
			v:setVisible(false);
		end   
		for _,v in pairs(self.keyText) do
			v:setVisible(false);
		end
		for _,v in pairs(self.keyBorderN) do
			v:setVisible(false);
		end
		self.keyBorder:setVisible(false);
		self.dynamicMapImage:setVisible(false);
		g_inGameMenu.btnFruitViewUp:setVisible(false);
		g_inGameMenu.btnFruitViewDown:setVisible(false);
		--Fruchttypen werden angezeigt!	
		local iShownRows=1;
		if self.mapView == InGameMenu.MAP_VIEW_FRUIT_TYPES then
			for i = 1, FruitUtil.NUM_FRUITTYPES do
				local desc = FruitUtil.fruitIndexToDesc[i];
				if desc.fruitMapColor ~= nil then
					if ts7_n_IGME_isVisibleFruit(self, desc.name) then
						local tmpSum = tmpKeyTextPosY-((tmpBmpSqrSize+tmpSpace)*(iShownRows-1));--math.floor(tmpFruits/tmpColumns));
						self.keyColor[(tmpFruits+tmpIgnoreKeyColor) + 1].imageColor = desc.fruitMapColor;
						if g_inGameMenu.FruitViewBeginRow <= tmpRows and iShownRows <= tmpMaxRowsVisible then
							self.keyColor[(tmpFruits+tmpIgnoreKeyColor) + 1].visible = true;
						end
						self.keyColor[(tmpFruits+tmpIgnoreKeyColor) + 1]:setSize(tmpBmpSqrSize,tmpBmpSqrSize);
						self.keyColor[(tmpFruits+tmpIgnoreKeyColor) + 1]:setPosition(keyTextPosX-tmpBmpSqrSize-tmpSpace+(tmpColumnWidth*tmpColumn) , tmpSum+(tmpBmpSqrSize/2));
						local fillType = FruitUtil.fruitTypeToFillType[i];
						local fruitName = Fillable.fillTypeIndexToDesc[fillType].nameI18N;
						self.keyText[(tmpFruits+tmpIgnore) + 1]:setText(fruitName);
						if g_inGameMenu.FruitViewBeginRow <= tmpRows and iShownRows <= tmpMaxRowsVisible then
							self.keyText[(tmpFruits+tmpIgnore) + 1].visible = true;
						end
						self.keyText[(tmpFruits+tmpIgnore) + 1]:setPosition(keyTextPosX+(tmpColumnWidth*tmpColumn) , tmpSum);
						self.keyText[(tmpFruits+tmpIgnore) + 1].text2Size = tmpTextSize;
						self.keyText[(tmpFruits+tmpIgnore) + 1].textSize = tmpTextSize;
						tmpFruits = tmpFruits + 1;
						tmpColumn = tmpColumn + 1;
					--end
						local ids = g_currentMission.fruits[i];
						if ids ~= nil and ids.id ~= 0 then
							for igor,fname in pairs (g_inGameMenu.densityMapFileNames) do
								if fname == getDensityMapFileName(ids.id) then
									--setFoliageStateOverlayFruitTypeColor(self.foliageStateOverlays[igor], ids.id, desc.fruitMapColor[1], desc.fruitMapColor[2], desc.fruitMapColor[3]);
									if desc.maxHarvestingGrowthState >= 0 then
										local witheredState = desc.maxHarvestingGrowthState + 1;
										if desc.maxPreparingGrowthState >= 0 then
											witheredState = desc.maxPreparingGrowthState + 1;
										end
										if witheredState ~= desc.cutState and witheredState ~= desc.preparedGrowthState and witheredState ~= desc.minPreparingGrowthState then
											setFoliageStateOverlayGrowthStateColor(self.foliageStateOverlays[igor], ids.id, witheredState + 1, desc.fruitMapColor[1], desc.fruitMapColor[2], desc.fruitMapColor[3]);
										end
										local maxGrowingState = desc.minHarvestingGrowthState - 1;
										if desc.minPreparingGrowthState >= 0 then
											maxGrowingState = math.min(maxGrowingState, desc.minPreparingGrowthState - 1);
										end
										for i = 0, maxGrowingState do
											setFoliageStateOverlayGrowthStateColor(self.foliageStateOverlays[igor], ids.id, i + 1, desc.fruitMapColor[1], desc.fruitMapColor[2], desc.fruitMapColor[3]);
										end
										if desc.minPreparingGrowthState >= 0 then
											for i = desc.minPreparingGrowthState, desc.maxPreparingGrowthState do
												setFoliageStateOverlayGrowthStateColor(self.foliageStateOverlays[igor], ids.id, i + 1, desc.fruitMapColor[1], desc.fruitMapColor[2], desc.fruitMapColor[3]);
											end
										end
										for i = desc.minHarvestingGrowthState, desc.maxHarvestingGrowthState do
											setFoliageStateOverlayGrowthStateColor(self.foliageStateOverlays[igor], ids.id, i + 1, desc.fruitMapColor[1], desc.fruitMapColor[2], desc.fruitMapColor[3]);
										end
									end
								end
							end
						end
					end
				end
				if tmpColumn == tmpColumns then
					tmpColumn = 0;
					if g_inGameMenu.FruitViewBeginRow <= tmpRows then
						iShownRows = iShownRows + 1;
					end
					tmpRows = tmpRows + 1;
				end
			end
			tmpRows = math.ceil(tmpFruits/tmpColumns);
			local tmpRowsVisible = tmpRows;
			if tmpRows > tmpMaxRowsVisible then
				tmpRowsVisible = tmpMaxRowsVisible;
			end
			for i = 1, tmpColumns do
				self.keyBorderN[i].size[1] = tmpBmpSqrSize+tmpSpace;
				self.keyBorderN[i].size[2] = (tmpRowsVisible * (tmpBmpSqrSize+tmpSpace));
				self.keyBorderN[i]:setPosition(keyTextPosX-self.keyBorderN[i].size[1]-(tmpSpace/2)+(tmpColumnWidth*(i-1)) , tmpKeyTextPosY-self.keyBorderN[i].size[2]+(tmpBmpSqrSize*2)-tmpSpace);
				self.keyBorderN[i]:setVisible(true);
			end
			self.dynamicMapImageLoading:setVisible(true);
			if g_inGameMenu.FruitViewBeginRow > 1 then
				g_inGameMenu.btnFruitViewUp:setPosition(0.6,0.25);
				g_inGameMenu.btnFruitViewUp:setVisible(true);
			
			end
			if tmpRows - tmpMaxRowsVisible - g_inGameMenu.FruitViewBeginRow >= 0 then
				g_inGameMenu.btnFruitViewDown:setPosition(0.8,0.25);
				g_inGameMenu.btnFruitViewDown:setVisible(true);
			end
			for igor,fOver in pairs (self.foliageStateOverlays) do
				generateFoliageStateOverlayGrowthStateColors(fOver);
				getIsFoliageStateOverlayReady(fOver);
				generateFoliageStateOverlayFruitTypeColors(fOver);
			end
			self:checkFoliageStateOverlayReady();
		end
		--Wachstum wird angezeigt!
		if self.mapView == InGameMenu.MAP_VIEW_GROWTH then
			--Wachstum
			for i = 1, #self.growthGrowingColors do
				self.keyColor[i].imageColor = self.growthGrowingColors[i];
				self.keyColor[i]:setVisible(true);
				self.keyColor[i]:setPosition(keyTextPosX-tmpSpace-(tmpGrowthBmpSqrSize)+(tmpGrowthBmpSqrSize/4*(i-1)) , tmpKeyTextPosY+(tmpGrowthBmpSqrSize/2));
				self.keyColor[i]:setSize(tmpGrowthBmpSqrSize/4 , tmpGrowthBmpSqrSize);
			end
			self.keyText[1]:setText(g_i18n:getText("growthGrowingMapDesc"));
			self.keyText[1]:setVisible(true);
			self.keyText[1]:setPosition(keyTextPosX, tmpKeyTextPosY);
			self.keyText[1].text2Size = tmpGrowthTextSize;
			self.keyText[1].textSize = tmpGrowthTextSize;	
			--Erntereif
			for i = 1, #self.growthReadyToHarvestColors do
				self.keyColor[4+i].imageColor = self.growthReadyToHarvestColors[i];
				self.keyColor[4+i]:setVisible(true);
				self.keyColor[4+i]:setPosition(keyTextPosX-tmpSpace-(tmpGrowthBmpSqrSize)+(tmpGrowthBmpSqrSize/4*(i-1)) , tmpKeyTextPosY+(tmpGrowthBmpSqrSize/2)-((tmpGrowthBmpSqrSize+tmpSpace)*1));
				self.keyColor[4+i]:setSize(tmpGrowthBmpSqrSize/4 , tmpGrowthBmpSqrSize);
			end
			self.keyText[2]:setText(g_i18n:getText("growthReadyToHarvestMapDesc"));
			self.keyText[2]:setVisible(true);
			self.keyText[2]:setPosition(keyTextPosX, tmpKeyTextPosY-((tmpGrowthBmpSqrSize+tmpSpace)*1));
			self.keyText[2].text2Size = tmpGrowthTextSize;
			self.keyText[2].textSize = tmpGrowthTextSize;
			--Vorbereitungsreife
			self.keyColor[9].imageColor = self.growthReadyToPrepareColor;
			self.keyColor[9]:setVisible(true);
			self.keyColor[9]:setPosition(keyTextPosX-tmpSpace-(tmpGrowthBmpSqrSize) , tmpKeyTextPosY+(tmpGrowthBmpSqrSize/2)-((tmpGrowthBmpSqrSize+tmpSpace)*2));
			self.keyColor[9]:setSize(tmpGrowthBmpSqrSize/2 , tmpGrowthBmpSqrSize);
			self.keyText[3]:setText(g_i18n:getText("growthReadyToPrepareForHarvestMapDesc"));
			self.keyText[3]:setVisible(true);
			self.keyText[3]:setPosition(keyTextPosX, tmpKeyTextPosY-((tmpGrowthBmpSqrSize+tmpSpace)*2));
			self.keyText[3].text2Size = tmpGrowthTextSize;
			self.keyText[3].textSize = tmpGrowthTextSize;
			--Verfault
			self.keyColor[13].imageColor = self.growthWitheredColor;
			self.keyColor[13]:setVisible(true);
			self.keyColor[13]:setPosition(keyTextPosX-tmpSpace-(tmpGrowthBmpSqrSize) , tmpKeyTextPosY+(tmpGrowthBmpSqrSize/2)-((tmpGrowthBmpSqrSize+tmpSpace)*3));
			self.keyColor[13]:setSize(tmpGrowthBmpSqrSize/2 , tmpGrowthBmpSqrSize);
			self.keyText[4]:setText(g_i18n:getText("growthWitheredMapDesc"));
			self.keyText[4]:setVisible(true);
			self.keyText[4]:setPosition(keyTextPosX, tmpKeyTextPosY-((tmpGrowthBmpSqrSize+tmpSpace)*3));
			self.keyText[4].text2Size = tmpGrowthTextSize;
			self.keyText[4].textSize = tmpGrowthTextSize;
			for fruitType,ids in pairs(g_currentMission.fruits) do
				if ids.id ~= 0 then
					local desc = FruitUtil.fruitIndexToDesc[fruitType];
					if ts7_n_IGME_isVisibleFruit(self, desc.name) then
						if desc.maxHarvestingGrowthState >= 0 then
							local witheredState = desc.maxHarvestingGrowthState + 1;
							if desc.maxPreparingGrowthState >= 0 then
								witheredState = desc.maxPreparingGrowthState + 1;
							end
							if witheredState ~= desc.cutState and witheredState ~= desc.preparedGrowthState and witheredState ~= desc.minPreparingGrowthState then
								for igor,fname in pairs (g_inGameMenu.densityMapFileNames) do
									if fname == getDensityMapFileName(ids.id) then
										setFoliageStateOverlayGrowthStateColor(self.foliageStateOverlays[igor], ids.id, witheredState + 1, self.growthWitheredColor[1], self.growthWitheredColor[2], self.growthWitheredColor[3]);
									end
								end							
							end
							local maxGrowingState = desc.minHarvestingGrowthState - 1;
							if desc.minPreparingGrowthState >= 0 then
								maxGrowingState = math.min(maxGrowingState, desc.minPreparingGrowthState - 1);
							end
							for i = 0, maxGrowingState do
								local index = math.min(i + 1, #self.growthGrowingColors);
								for igor,fname in pairs (g_inGameMenu.densityMapFileNames) do
									if fname == getDensityMapFileName(ids.id) then
										setFoliageStateOverlayGrowthStateColor(self.foliageStateOverlays[igor], ids.id, i + 1, self.growthGrowingColors[index][1], self.growthGrowingColors[index][2], self.growthGrowingColors[index][3]);
									end
								end
							end
							if desc.minPreparingGrowthState >= 0 then
								for i = desc.minPreparingGrowthState, desc.maxPreparingGrowthState do
									for igor,fname in pairs (g_inGameMenu.densityMapFileNames) do
										if fname == getDensityMapFileName(ids.id) then
											setFoliageStateOverlayGrowthStateColor(self.foliageStateOverlays[igor], ids.id, i + 1, self.growthReadyToPrepareColor[1], self.growthReadyToPrepareColor[2], self.growthReadyToPrepareColor[3]);
										end
									end
								end
							end
							for i = desc.minHarvestingGrowthState, desc.maxHarvestingGrowthState do
								local index = math.min(i - desc.minHarvestingGrowthState + 1, #self.growthReadyToHarvestColors);
								for igor,fname in pairs (g_inGameMenu.densityMapFileNames) do
									if fname == getDensityMapFileName(ids.id) then
										setFoliageStateOverlayGrowthStateColor(self.foliageStateOverlays[igor], ids.id, i + 1, self.growthReadyToHarvestColors[index][1], self.growthReadyToHarvestColors[index][2], self.growthReadyToHarvestColors[index][3]);
									end
								end
							end
						end
					end
				end
			end
			self.keyBorder.size[1] = tmpGrowthBmpSqrSize+tmpSpace;
			self.keyBorder.size[2] = ((tmpGrowthBmpSqrSize+tmpSpace)*4)+(tmpSpace*2);
			self.keyBorder:setPosition(keyTextPosX-self.keyBorder.size[1]-(tmpSpace/2) , tmpKeyTextPosY - self.keyBorder.size[2] + (tmpGrowthBmpSqrSize*2)-tmpSpace);
			self.keyBorder:setVisible(true);
			self.dynamicMapImageLoading:setVisible(true);
			for igor,fOver in pairs (self.foliageStateOverlays) do
				generateFoliageStateOverlayGrowthStateColors(fOver);
				getIsFoliageStateOverlayReady(fOver);
				generateFoliageStateOverlayFruitTypeColors(fOver);
			end	
			self:checkFoliageStateOverlayReady();
		end
	end
	if self.mode == InGameMenu.MODE_VEHICLE_SELECTION then
		self:updateVehicleSelectionIcons();
	end
	if self.mode == InGameMenu.MODE_SETTINGS then
	end
	self:updateFocusLinkageSystem();
end
ts7_n_IGME_checkFoliageStateOverlayReady = function(self) --modified from InGameMenu.lua
	if InGameMenu.MODE_MAP_VIEWS and not self.dynamicMapImage.visible and getIsFoliageStateOverlayReady(self.foliageStateOverlay) then
		--local bIFSOR = true;
		--for igor,fOver in pairs (self.foliageStateOverlays) do
		--	if not getIsFoliageStateOverlayReady(fOver) then
		--	
		--	else
		--		bIFSOR = false;
		--	end
		--end
		--if bIFSOR then
			self.dynamicMapImage:setVisible(true);
			self.dynamicMapImageLoading:setVisible(false);
		--end
	end
end
ts7_n_CE_load = function (self, xmlFile)
	self.cultivatorForceLimitToField = false;
	self.cultivatorLimitToField = true;
end
ts7_n_CE_update = function (self, dt)
	if self:getIsActiveForInput() then
		if InputBinding.hasEvent(InputBinding.TS7_CE_LimitedToField) then
			self.cultivatorLimitToField = not self.cultivatorLimitToField;
		end
	end
end
ts7_n_CE_draw = function (self)
	if self.cultivatorLimitToField then
		g_currentMission:addHelpButtonText(string.format(g_i18n:getText("turn_off_OBJECT"), g_i18n:getText("TS7_CE_LimitedToField")),InputBinding.TS7_CE_LimitedToField);
	else
		g_currentMission:addHelpButtonText(string.format(g_i18n:getText("turn_on_OBJECT"), g_i18n:getText("TS7_CE_LimitedToField")),InputBinding.TS7_CE_LimitedToField);
	end
end
ts7_n_STDE_registerFruitType = function(name, nameI18N, needsSeeding, allowsSeeding, useSeedingWidth, directionSnapAngle, minHarvestingGrowthState, maxHarvestingGrowthState, cutState, allowsPartialGrowthState, pricePerLiter, literPerSqm, seedUsagePerSqm, partOfEconomy, hudOverlayFilename, fruitMapColor)--modified from FruitUtil.lua
	local key = "FRUITTYPE_" .. string.upper(name);
	if FruitUtil[key] == nil then
		FruitUtil.NUM_FRUITTYPES = FruitUtil.NUM_FRUITTYPES + 1;
		FruitUtil[key] = FruitUtil.NUM_FRUITTYPES;
		local desc = {name = name, index = FruitUtil.NUM_FRUITTYPES};
		desc.needsSeeding = needsSeeding;
		desc.allowsSeeding = allowsSeeding;
		desc.useSeedingWidth = useSeedingWidth;
		desc.directionSnapAngle = directionSnapAngle;
		desc.hasWindrow = false;
		desc.minHarvestingGrowthState = minHarvestingGrowthState;
		desc.maxHarvestingGrowthState = maxHarvestingGrowthState;
		desc.minPreparingGrowthState = -1;
		desc.maxPreparingGrowthState = -1;
		desc.preparedGrowthState = -1;
		desc.cutState = cutState;
		desc.allowsPartialGrowthState = allowsPartialGrowthState;
		desc.literPerSqm = literPerSqm;
		desc.seedUsagePerSqm = seedUsagePerSqm;
		desc.fruitMapColor = fruitMapColor;
		desc.forageWagonConversionSources = {};
		FruitUtil.fruitTypes[name] = desc;
		FruitUtil.fruitIndexToDesc[FruitUtil.NUM_FRUITTYPES] = desc;
		local fillType = Fillable.registerFillType(name, nameI18N, pricePerLiter, partOfEconomy, hudOverlayFilename);
		FruitUtil.fruitTypeToFillType[FruitUtil.NUM_FRUITTYPES] = fillType;
		FruitUtil.fillTypeToFruitType[fillType] = FruitUtil.NUM_FRUITTYPES;
	end
	return FruitUtil[key];
end
ts7_n_STDE_registerFillType = function(name, nameI18N, pricePerLiter, partOfEconomy, hudOverlayFilename)--modified from Fillable.lua
	local key = "FILLTYPE_" .. string.upper(name);
	if Fillable[key] == nil then
		Fillable.NUM_FILLTYPES = Fillable.NUM_FILLTYPES + 1;
		Fillable[key] = Fillable.NUM_FILLTYPES;
		Fillable.fillTypeNameToInt[name] = Fillable.NUM_FILLTYPES;
		Fillable.fillTypeIntToName[Fillable.NUM_FILLTYPES] = name;
		local desc = {};
		desc.name = name;
		desc.nameI18N = nameI18N;
		if desc.nameI18N == nil then
			desc.nameI18N = name;
		end
		if g_i18n:hasText(desc.nameI18N) then
			desc.nameI18N = g_i18n:getText(name);
		end
		desc.index = Fillable.NUM_FILLTYPES;
		desc.pricePerLiter = Utils.getNoNil(pricePerLiter, 0);
		desc.previousHourPrice = desc.pricePerLiter;
		desc.startPricePerLiter = desc.pricePerLiter;
		desc.totalAmount = Fillable.FILLTYPE_START_TOTAL_AMOUNT;
		desc.partOfEconomy = Utils.getNoNil(partOfEconomy, false);
		desc.hudOverlayFilename = hudOverlayFilename;
		Fillable.fillTypeIndexToDesc[Fillable.NUM_FILLTYPES] = desc;
		Fillable.fillTypeNameToDesc[name] = desc;
		if desc.partOfEconomy then
			table.insert(Fillable.economyFillTypes, desc);
		end
	end
	return Fillable[key];
end
ts7_n_IGME_updateSowingArea = function(fruitId, startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, angle, useDirectPlanting)--modified from FSUtil.lua
  local ids = g_currentMission.fruits[fruitId]
  if ids == nil or ids.id == 0 then
    return 0
  end
  angle = Utils.getNoNil(angle, 0)
  useDirectPlanting = Utils.getNoNil(useDirectPlanting, false)
  local desc = FruitUtil.fruitIndexToDesc[fruitId]
  local detailId = g_currentMission.terrainDetailId
  local sowingAddChannel = nil
  if desc.useSeedingWidth then
    sowingAddChannel = g_currentMission.sowingWidthChannel
  else
    sowingAddChannel = g_currentMission.sowingChannel
  end
  local excludeMask = 0
  if not useDirectPlanting then
    excludeMask = 2 ^ g_currentMission.sowingChannel + 2 ^ g_currentMission.sowingWidthChannel
  end
  local cultivatorChannel = g_currentMission.cultivatorChannel
  local ploughChannel = g_currentMission.ploughChannel
  local x, z, widthX, widthZ, heightX, heightZ = Utils.getXZWidthAndHeight(ids.id, startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ)
  local plantValue = 0
  --setDensityMaskParams(ids.id, "greater", 0, 0, 0, excludeMask)
  --setDensityMaskParams(ids.id, "greater", 0, 0, 0, 0)
  --setDensityCompareParams(ids.id, "greater", plantValue)
  --print ("1: id: "..ids.id.."  numFruitDensityMapChannels: "..g_currentMission.numFruitDensityMapChannels.."  DetailId: "..detailId.."  terrainDetail1st: "..g_currentMission.terrainDetailTypeFirstChannel.."  terrainDetailTypeNumC: "..g_currentMission.terrainDetailTypeNumChannels.."  Value: "..plantValue);
  --setDensityNewTypeIndexMode(ids.id, SET_INDEX_TO_ZERO)
  --setDensityTypeIndexCompareMode(ids.id, TYPE_COMPARE_NONE)
  --local _, numPixels1 = setDensityMaskedParallelogram(ids.id, x, z, widthX, widthZ, heightX, heightZ, 0, g_currentMission.numFruitDensityMapChannels, detailId, g_currentMission.terrainDetailTypeFirstChannel, g_currentMission.terrainDetailTypeNumChannels, plantValue)
setDensityMaskedParallelogram(ids.id, x, z, widthX, widthZ, heightX, heightZ, 0, 16, ids.id, 0, 16, 0);
--  setDensityParallelogram(ids.id,x,z,widhtX,widthZ,heightX,heightZ,0,256,0);
  --setDensityCompareParams(ids.id, "equals", 0)
  --print ("2: id: "..ids.id.."  numFruitDensityMapChannels: "..g_currentMission.numFruitDensityMapChannels.."  DetailId: "..detailId.."  terrainDetail1st: "..g_currentMission.terrainDetailTypeFirstChannel.."  terrainDetailTypeNumC: "..g_currentMission.terrainDetailTypeNumChannels.."  Value: "..plantValue);
  --local _, numPixels2, totalPixels = setDensityMaskedParallelogram(ids.id, x, z, widthX, widthZ, heightX, heightZ, 0, g_currentMission.numFruitDensityMapChannels, detailId, g_currentMission.terrainDetailTypeFirstChannel, g_currentMission.terrainDetailTypeNumChannels, plantValue)

  --setDensityCompareParams(ids.id, "greater", -1) 
 --local numPixels = numPixels1 + numPixels2
 local numPixels = 1;
  --setDensityMaskParams(ids.id, "greater", 0)
 --Utils.updateDestroyCommonArea (startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, true);

 local x, z, widthX, widthZ, heightX, heightZ = Utils.getXZWidthAndHeight(detailId, startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ)  
  local value = 2 ^ cultivatorChannel
  if fruitId == FruitUtil.FRUITTYPE_GRASS then
    value = 0
  end
  setDensityMaskParams(detailId, "greater", 0, 0, 0, excludeMask)
  --print ("3: detailid: "..detailId.."  terrainDetailType1St: "..g_currentMission.terrainDetailTypeFirstChannel.."  terrainDetailTypeNumCh: "..g_currentMission.terrainDetailTypeNumChannels.."  value: "..value);
  local _, numDetailPixels = setDensityMaskedParallelogram(detailId, x, z, widthX, widthZ, heightX, heightZ, g_currentMission.terrainDetailTypeFirstChannel, g_currentMission.terrainDetailTypeNumChannels, detailId, g_currentMission.terrainDetailTypeFirstChannel, g_currentMission.terrainDetailTypeNumChannels, value)
  setDensityMaskParams(detailId, "greater", 0)
  if value > 0 then
  --print ("4: detailid: "..detailId.."  terrainDetailAngle1St: "..g_currentMission.terrainDetailAngleFirstChannel.."  terrainDetailAngleNumCh: "..g_currentMission.terrainDetailAngleNumChannels.."  sowingAddChannel: "..sowingAddChannel.."  angle: "..angle);
	setDensityMaskedParallelogram(detailId, x, z, widthX, widthZ, heightX, heightZ, g_currentMission.terrainDetailAngleFirstChannel, g_currentMission.terrainDetailAngleNumChannels, detailId, sowingAddChannel, 1, angle)
  end
  return numPixels, numDetailPixels
end
ts7_n_IGME_updateDestroyCommonArea = function(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, limitToField)--modified from FSUtil.lua
	-- upvalues: SET_INDEX_TO_ZERO , TYPE_COMPARE_NONE , UPDATE_INDEX , TYPE_COMPARE_EQUAL
	limitToField = Utils.getNoNil(limitToField, false);
	local detailId = g_currentMission.terrainDetailId
	for index,entry in pairs(g_currentMission.fruits) do
		local x, z, widthX, widthZ, heightX, heightZ = Utils.getXZWidthAndHeight(entry.id, startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ)
		setDensityNewTypeIndexMode(entry.id, SET_INDEX_TO_ZERO)
		setDensityTypeIndexCompareMode(entry.id, TYPE_COMPARE_NONE)
		if limitToField then
			setDensityMaskedParallelogram(entry.id, x, z, widthX, widthZ, heightX, heightZ, 0, g_currentMission.numFruitDensityMapChannels, detailId, g_currentMission.terrainDetailTypeFirstChannel, g_currentMission.terrainDetailTypeNumChannels, 0)
		else	
			setDensityParallelogram(entry.id, x, z, widthX, widthZ, heightX, heightZ, 0, g_currentMission.numFruitDensityMapChannels, 0)
		end
		setDensityNewTypeIndexMode(entry.id, UPDATE_INDEX)
		setDensityTypeIndexCompareMode(entry.id, TYPE_COMPARE_EQUAL)
	end
	for i = 1, table.getn(g_currentMission.dynamicFoliageLayers) do
		local id = g_currentMission.dynamicFoliageLayers[i]
		local numChannels = getTerrainDetailNumChannels(id)
		local x, z, widthX, widthZ, heightX, heightZ = Utils.getXZWidthAndHeight(id, startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ)
		if limitToField then
			setDensityMaskedParallelogram(id, x, z, widthX, widthZ, heightX, heightZ, 0, numChannels, detailId, g_currentMission.terrainDetailTypeFirstChannel, g_currentMission.terrainDetailTypeNumChannels, 0)
		else
			setDensityParallelogram(id, x, z, widthX, widthZ, heightX, heightZ, 0, numChannels, 0)
		end
	end
	
end
ts7_n_IGME_main = function (self)
	local strMod = "InGameMenuEnhancement";
	local tmpParent = g_gui.guis["InGameMenu"].elements[1].elements[2];
	if ts7_mods == nil then
		ts7_mods = {};
	end
	if ts7_mods[strMod] == nil then
		ts7_mods[strMod] = {};
		print (strMod.." Mod InGameMenuEnhancement from (c)BlueTiger by Team-SUB7 is loading!");
		g_inGameMenu.FruitViewBeginRow = 1;
		ts7_mods[strMod].reload = true;
		ts7_mods[strMod].fruittypes = 0;
		ts7_mods[strMod].file = g_currentModDirectory.."InGameMenuEnhancement.xml";
	end
	g_inGameMenu.updateGUI = ts7_n_IGME_updateGUI;
	g_inGameMenu.onCreateBtnFruitViewUp = ts7_n_IGME_onCreateBtnFruitViewUp;
	g_inGameMenu.onCreateBtnFruitViewDown = ts7_n_IGME_onCreateBtnFruitViewDown;
	g_inGameMenu.onClickBtnFruitViewUp = ts7_n_IGME_onClickBtnFruitViewUp;
	g_inGameMenu.onClickBtnFruitViewDown = ts7_n_IGME_onClickBtnFruitViewDown;
	g_inGameMenu.setMissionInfo = ts7_n_IGME_setMissionInfo;
	g_inGameMenu.onOpen = ts7_n_IGME_onOpen;
	g_inGameMenu.checkFoliageStateOverlayReady = ts7_n_IGME_checkFoliageStateOverlayReady;
	tmpParent.elements[3].onDrawCallback = ts7_n_IGME_drawDynamicMapImage;
	Utils.updateDestroyCommonArea = ts7_n_IGME_updateDestroyCommonArea;
	FruitUtil.registerFruitType = ts7_n_STDE_registerFruitType;
	Fillable.registerFillType = ts7_n_STDE_registerFillType;
end

addModEventListener(ts7_n_IGME);
Cultivator.load   = Utils.appendedFunction(Cultivator.load, ts7_n_CE_load);
Cultivator.update = Utils.appendedFunction(Cultivator.update, ts7_n_CE_update);
Cultivator.draw   = Utils.appendedFunction(Cultivator.draw, ts7_n_CE_draw);
ts7_n_IGME_main();